-- scene
local scene = getCurrentScene()
-- viewport (background)
local viewport = Viewport(scene:getObjectByName("viewport"))
local im = getInputManager()
local touchscreen  = TouchScreen(im:getDevice(TIINPUT_TOUCHSCREENDEVICE))
touchscreen:acquire()
-- 3D object receiving tracking pose
local ref = Object3D(scene:getObjectByName("Tracking_Object"))
-- check if 3D object is visible, the default value is false.
local isVisible = false
-- use getComponentInterface() function in order to communicate with high level application
local componentInterface = getComponentInterface()


local x1_list = {}
local y1_list = {}

local x2_list = {}
local y2_list = {}
local x3_list = {}
local y3_list = {}

local touch_index1 =0
local touch_index2 =0
local act_type = ""

pinch_flag = false

coroutine.yield()

repeat

	
	
	local touches = touchscreen:getTouches()
	if (#touches > 0) then
		
		if (#touches == 1) then
			act_type = "swipe"
		elseif (#touches == 2) then
			act_type = "pinch"
			--Płpinch̃tOĂ΁Aswipe𖳎
			pinch_flag = true
			
		elseif (#touches == 3) then
			componentInterface:executeAppFunc("touches","3")
		end
		
		local t1 = touches[1]
			local obj1 = viewport:pick(t1.position.x, t1.position.y)
		
		if (act_type == "swipe") then

			x1_list[touch_index1] = t1.position.x
			y1_list[touch_index1] = t1.position.y
			touch_index1 = touch_index1 + 1
		end
		
		
		if (act_type == "pinch") then
			
			local t2 = touches[2]
			local obj2 = viewport:pick(t2.position.x, t2.position.y)
			
			x2_list[touch_index2] = t1.position.x
			y2_list[touch_index2] = t1.position.y
			
			x3_list[touch_index2] = t2.position.x
			y3_list[touch_index2] = t2.position.y
			
			touch_index2 = touch_index2 + 1
		
		end
		
	else
		
		if (pinch_flag == false) then
			
			if touch_index1 ~= 0 then
				--("swipe")	
				if touch_index1 ~= 1 then
					start_x1 = x1_list[0]
					start_y1 = y1_list[0]
					
					end_x1 = x1_list[touch_index1 - 1]
					end_y1 = y1_list[touch_index1 - 1]
					
					lamda_x = math.abs(start_x1 - end_x1)
					lamda_y = math.abs(start_y1 - end_y1)
					
					if lamda_y < lamda_x then
						if start_x1 < end_x1 then
							--Eswipe
							componentInterface:executeAppFunc("flick","right",lamda_x)
						else
							--swipe
							componentInterface:executeAppFunc("flick","left",lamda_x)
						end
					else
						if start_y1 > end_y1 then
							--("UP")
							
							orient_x = orient_x - 10	
							if orient_x == 0 then
				            	orient_x = 360
				            end
				            
						elseif start_y1 < end_y1 then
							--("DOWN")
							
				            orient_x = orient_x + 10
				            if orient_x == 360 then
				            	orient_x = 0
				            end
				            
						end
					end
				end
			end
		
		else
			
			if touch_index2 ~= 0 then
				--("pinch")	
				if touch_index2 ~= 1 then
					start_x1 = x2_list[0]
					start_y1 = y2_list[0]
					
					end_x1 = x2_list[touch_index2 - 1]
					end_y1 = y2_list[touch_index2 - 1]
					
					start_x2 = x3_list[0]
					start_y2 = y3_list[0]
					
					end_x2 = x3_list[touch_index2 - 1]
					end_y2 = y3_list[touch_index2 - 1]
					
					
					lamda_startx = math.abs(start_x1 - start_x2)
					lamda_endx = math.abs(end_x1 - end_x2)
					
					if lamda_startx > lamda_endx then
						--("PINCH IN")
						miku_scale = miku_scale - 0.1
						if miku_scale <= 0 then
							miku_scale = 0.1
						end
					else
						--("PINCH OUT")
						miku_scale = miku_scale + 0.1
					end
					
				end
			end
		end
		
		x1_list = {}
		y1_list = {}
		x2_list = {}
		y2_list = {}
		x3_list = {}
		y3_list = {}
		touch_index1 =0
		touch_index2 =0
		pinch_flag = false
	end
	

until coroutine.yield()
